<?php

/*
=====================================================
 Module for Joomla - by SmsCoin
-----------------------------------------------------
 http://smscoin.com
-----------------------------------------------------
 Copyright (c) 2011 SmsCoin
=====================================================
 Файл: smscoin_rkey.php
-----------------------------------------------------
 Purpose: payment module via SMS message
=====================================================
*/

/**
 * Защита от прямого доступа к файлу
 */
defined('_JEXEC') or die('Restricted access');

/**
 * Подключаем главный плагин Joomla
 */
jimport('joomla.plugin.plugin');

class plgContentSmscoin_rkey extends JPlugin {

    /**
    * @param object $subject Объект наблюдения...
    * @param object $config  Объект, который содержит параметры...
    */
    public function __construct(&$subject, $config = array()) {

	parent::__construct($subject, $config);
	$this->loadLanguage();
    }
    
    /**
     * @param object $context Объект, наблюдения
     * @param object $article Объект, который содержит параметры материала
     * @param object $params Объект, который содержит параметры
     * @param int $page номер страницы
     */
    public function onContentBeforeDisplay($context, &$row, &$params, $page=0) {

	$dbo = &JFactory::getDbo();
	$query = $dbo->getQuery(true);
	$user = &JFactory::getUser();
	$baseurl = JURI::base();

	/**
	 * Инициализация праметров...
	 */
	$key_id = $this->params->get('key_id');
	$cron_time = $this->params->get('cron_time');
	$secret_code = $this->params->get('secret_code');
	$language = $this->params->get('language', 'russian');
	$tag_name = $this->params->get('tag');
	$vip_time = $this->params->get('vip_time');
	$subject = $this->params->get('subject');
	$body = $this->params->get('body');
	$access = $this->params->get('access');

	if (!$page) {
	    $page = 0;
	}

	/**
	 * Обновление тарифной сетки
	 */
	if(($cron_time + 3600) < time(true)) {

	@ini_set('user_agent', 'smscoin_key_cron');
	$cron_info = '<br />';

	if(is_numeric($key_id) && $key_id != 0) {
	    $response = file_get_contents("http://key.smscoin.com/language/$language/json/key/".$key_id."/");
		if(preg_match('|(JSONResponse = \[.*\])|is', $response, $feed) > 0) {
		    if ($response !== false) {
			$filename = dirname(__FILE__).'/lib/local.js';
			if (($hnd = @fopen($filename, 'w')) !== false) {
			    if (@fwrite($hnd, $response) !== false) {
				$cron_info.= ('Success, file local.js updated @ '.date("r"));
				/**
				 * Запись времени обновления тарифной сетки...
				 */
				$plg_params = array('key_id' => $key_id,
				    'secret_code' => $secret_code,
				    'cron_time' => time(true),
				    'tag' => $tag_name,
				    'hidetag' => $tag_hide_name,
				    'vip_time' => $vip_time,
				    'language' => $language,
				    'subject' => $subject,
				    'body' => $body,
				    'access' => $access
				    );

				$dbo->setQuery("UPDATE #__extensions SET `params` = '".json_encode($plg_params)."' WHERE `element` = 'smscoin_rkey'");
				$dbo->query();

			    } else {
				$cron_info.= ('File local.js not writeable');
			    }
				fclose($hnd);
			} else {
			    $cron_info.= ('Could not open file local.js');
			}
		    } else {
			$cron_info.= ('Unable to connect to remote server');
		    }
		}
	    }
	}
    
    empty($row->text) ? $row->text = 1 : '';
	$content = str_replace("\n", "__CRLF__", $row->text);
	
	/**
	 * Форма вывода инструкций
	 */
	$smsform = '
	    <script type="text/javascript">
		var JSON_URL = "'. $baseurl .'/plugins/content/smscoin_rkey/lib/local.js";
		var SERVICE = "'. $key_id .'";
		var SELECT_PROVIDER = "'. JText::_('SELECT_PROVIDER') .'";
		var INCLUDING_VAT = "'. JText::_('INCLUDING_VAT') .'";
		var WITHOUT_VAT = "'. JText::_('WITHOUT_VAT') .'";
	    </script>
	    <script src="'. $baseurl .'/plugins/content/smscoin_rkey/lib/dropdown.js" type="text/javascript"></script>
	    <link rel="stylesheet" href="'. $baseurl .'/plugins/content/smscoin_rkey/viewer.css" type="text/css" />
	    <div align="center">
		<div id="ui" class="dropdown">
		    <h4>'. JText::_('IF_YOU_HAVE_ALREADY_RECEIVED_THE_PASSWORD_PLEASE_ENTER_IT_HERE') .'</h4>
		    <form action = "http://'. $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"] .'" method="POST">
			<div>
			    <input type="text" value="" name="s_pair"/>
			    <input type="submit" value="'. JText::_('CONTINUE') .'"/>
			</div>
		    </form><br /> '. JText::_('SELECT_COUNTRY') .':
		    <select id="select_country">
			<option value="-">'. JText::_('SELECT_COUNTRY') .'</option>
		    </select>
		    <div id="providers" style="display: none"> '. JText::_('SELECT_PROVIDER') .':
			<select id="select_provider">
			    <option value="-">'. JText::_('SELECT_PROVIDER') .'</option>
			</select>
		    </div>
		    <div id="instructions" style="display: none">
			<p>'. JText::_('IN_ORDER_TO_RECEIVE_A_PASSWORD_PLEASE_SEND_A_MESSAGE') .
			' <span id="message_text"></span> '. JText::_('TO_THE_PHONE_NUMBER') .' <span id="shortcode"></span>.</p>
			<p>'. JText::_('THE_MESSAGE_WILL_COST_YOU') .' <span id="message_cost"></span>.</p>
			<p>'. JText::_('YOU_WILL_RECEIVE_YOUR_PASSWORD_IN_REPLY') .'.</p>
			<p>'. JText::_('CAUTION') .'</p>
			<p>'. JText::_('PAY_ATTENTION_TO_THE_MESSAGE_TEXT_AND_ESPECIALLY_SPACES') .'.</p>
			<p>'. JText::_('ALL_THE_LETTERS_ARE_LATIN') .'.</p>
			<p>'. JText::_('YOULL_BE_CHARGED_THE_FULL_PRICE_EVEN_IN_CASE_OF_AN_ERROR') .'.</p>
			<p id="notes" style="display: none"></p>
		    </div>
		</div>
		<div id="fail" style="display: none">
		    <h1></h1>
		</div>
	    </div>';

	/**
	 * Вывод скрытого контента
	 */
	if(preg_match('/\\['. $tag_name .'\\](.*?)\\[\\/'. $tag_name .'\\]/is', $content, $matches)) {

		$result = 0;
		if (isset($_POST['s_pair']) && $_POST['s_pair'] !='' && strlen($_POST['s_pair']) <= 10) {

		    /**
		     * Проверка пароля
		     */
		    $result = $this->do_key_local_check($key_id, $_POST['s_pair'], $dbo);
		}
		
		/**
		 * Проверка принадлежности пользователя к группе VIP
		 */
		$query->clear();
		$query->select('*')->from('#__svip');
		$query->where('uid = '. $user->id)
			->where('vip = 0');
		$dbo->setQuery($query);
		$res = $dbo->loadObject();
		
		if ($result != 1 && !$res) {
		    /**
		     * Вывод инструкции по отправке смс
		     */
		    $content = preg_replace('/\\['. $tag_name .'\\].*?\\[\\/'. $tag_name .'\\]/is', $smsform, $content);
		} else {
		    /**
		     * Вывод скрытого контента
		     */
		    $content = preg_replace('/\\['. $tag_name .'\\].*?\\[\\/'. $tag_name .'\\]/is', $matches[1], $content);
		}
		
	} else {
	    $content = preg_replace('/\\['. $tag_name .'\\].*?\\[\\/'. $tag_name .'\\]/is', '', $content);
	}

	$row->text = str_replace("__CRLF__", "\n", $content);
    }

    /**
     * Функция проверки пароля
     * @param int $key
     * @param string $pair
     * @param object $db
     * @return int
     */
    function do_key_local_check($key, $pair, &$dbo) {
	$dbo = &JFactory::getDbo();
	$query = $dbo->getQuery(true);
	$do_die = 0;
	if (isset($pair) && $pair !='' && strlen($pair)<=10) {
		/**
		 * Проверка пароля
		 */
		$query->clear();
		$query->select('*')->from('#__skeys');
		$query->where('k_status = 1')
			->where('k_pair = ' . $dbo->Quote($pair))
			->where('k_key = ' . (int)$key);
		$dbo->setQuery($query);
		$data = $dbo->loadObject();

		if ($data) {
		    /**
		     * Пароль верный
		     */
		    if ($data->k_first_access == 0) {
			/**
			 * Первая активация
			 */
			$dbo->setQuery("UPDATE #__skeys
					SET `k_first_access`='". time(true) ."',
					    `k_first_ip`='". addslashes($_SERVER["REMOTE_ADDR"]) ."',
					    `k_first_from`='". addslashes($_SERVER["SERVER_NAME"] . $_SERVER["REQUEST_URI"])."'". ($data->k_limit_current > 0 ? ",
					    `k_limit_current`=k_limit_current-1" : "") ."
					WHERE `k_pair`='". addslashes($pair) ."' AND `k_key`='". (int)$key ."'");
			$dbo->query();
			$do_die = 1;

			} elseif ($data->k_timeout == 0 || ($data->k_first_access + $data->k_timeout * 60) > time(true)) {
			    /**
			     * Другие активации
			     */
			    if ($data->k_limit_start > 0) {
				if ($data->k_limit_current > 0) {

				    $dbo->setQuery("UPDATE #__skeys
					SET k_limit_current=k_limit_current-1
					WHERE k_pair='".addslashes($pair)."'
					AND k_key='".intval($key)."' AND k_limit_current>0");
				    
				    $db->query();
				    $do_die = 1;
				}
			    } else {
				$do_die = 1;
			    }
			}
		} else {
			/**
			 * Пароль ошибочен
			 */
			$do_die = 2;
		}
	}
	return $do_die;
    }
}
